/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "../src/bc/bc.y"

/*	$OpenBSD: bc.y,v 1.46 2014/10/14 15:35:18 deraadt Exp $	*/

/*
 * Copyright (c) 2003, Otto Moerbeek <otto@drijf.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * This implementation of bc(1) uses concepts from the original 4.4
 * BSD bc(1). The code itself is a complete rewrite, based on the
 * Posix defined bc(1) grammar. Other differences include type safe
 * usage of pointers to build the tree of emitted code, typed yacc
 * rule values, dynamic allocation of all data structures and a
 * completely rewritten lexical analyzer using lex(1).
 *
 * Some effort has been made to make sure that the generated code is
 * the same as the code generated by the older version, to provide
 * easy regression testing.
 */

#include <sys/cdefs.h>
__FBSDID("$FreeBSD$");

#include <sys/types.h>
#include <sys/wait.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <getopt.h>
#include <histedit.h>
#include <limits.h>
#include <search.h>
#include <signal.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include "extern.h"
#include "pathnames.h"

#define BC_VER		"1.1-FreeBSD"
#define END_NODE	((ssize_t) -1)
#define CONST_STRING	((ssize_t) -2)
#define ALLOC_STRING	((ssize_t) -3)

extern char	*yytext;
extern FILE	*yyin;

struct tree {
	union {
		char		*astr;
		const char	*cstr;
	} u;
	ssize_t			index;
};

int			 yywrap(void);

int			 fileindex;
int			 sargc;
const char		**sargv;
const char		*filename;
char			*cmdexpr;

static void		 grow(void);
static ssize_t		 cs(const char *);
static ssize_t		 as(const char *);
static ssize_t		 node(ssize_t, ...);
static void		 emit(ssize_t, int);
static void		 emit_macro(int, ssize_t);
static void		 free_tree(void);
static ssize_t		 numnode(int);
static ssize_t		 lookup(char *, size_t, char);
static ssize_t		 letter_node(char *);
static ssize_t		 array_node(char *);
static ssize_t		 function_node(char *);

static void		 add_par(ssize_t);
static void		 add_local(ssize_t);
static void		 warning(const char *);
static void		 init(void);
static void		 usage(void);
static char		*escape(const char *);

static ssize_t		 instr_sz = 0;
static struct tree	*instructions = NULL;
static ssize_t		 current = 0;
static int		 macro_char = '0';
static int		 reset_macro_char = '0';
static int		 nesting = 0;
static int		 breakstack[16];
static int		 breaksp = 0;
static ssize_t		 prologue;
static ssize_t		 epilogue;
static bool		 st_has_continue;
static char		 str_table[UCHAR_MAX][2];
static bool		 do_fork = true;
static u_short		 var_count;
static pid_t		 dc;

static void		 sigchld(int);

extern char		*__progname;

#define BREAKSTACK_SZ	(sizeof(breakstack)/sizeof(breakstack[0]))

/* These values are 4.4BSD bc compatible */
#define FUNC_CHAR	0x01
#define ARRAY_CHAR	0xa1

/* Skip '\0', [, \ and ] */
#define ENCODE(c)	((c) < '[' ? (c) : (c) + 3);
#define VAR_BASE	(256-4)
#define MAX_VARIABLES	(VAR_BASE * VAR_BASE)

const struct option long_options[] =
{
	{"expression",	required_argument,	NULL,	'e'},
	{"help",	no_argument,		NULL,	'h'},
	{"mathlib",	no_argument,		NULL,	'l'},
	/* compatibility option */
	{"quiet",	no_argument,		NULL,	'q'},
	{"version",	no_argument,		NULL,	'v'},
	{NULL,		no_argument,		NULL,	0}
};


#line 213 "src/bc/bc.p/bc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "bc.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_COMMA = 3,                      /* COMMA  */
  YYSYMBOL_SEMICOLON = 4,                  /* SEMICOLON  */
  YYSYMBOL_LPAR = 5,                       /* LPAR  */
  YYSYMBOL_RPAR = 6,                       /* RPAR  */
  YYSYMBOL_LBRACE = 7,                     /* LBRACE  */
  YYSYMBOL_RBRACE = 8,                     /* RBRACE  */
  YYSYMBOL_LBRACKET = 9,                   /* LBRACKET  */
  YYSYMBOL_RBRACKET = 10,                  /* RBRACKET  */
  YYSYMBOL_DOT = 11,                       /* DOT  */
  YYSYMBOL_NEWLINE = 12,                   /* NEWLINE  */
  YYSYMBOL_LETTER = 13,                    /* LETTER  */
  YYSYMBOL_NUMBER = 14,                    /* NUMBER  */
  YYSYMBOL_STRING = 15,                    /* STRING  */
  YYSYMBOL_DEFINE = 16,                    /* DEFINE  */
  YYSYMBOL_BREAK = 17,                     /* BREAK  */
  YYSYMBOL_QUIT = 18,                      /* QUIT  */
  YYSYMBOL_LENGTH = 19,                    /* LENGTH  */
  YYSYMBOL_RETURN = 20,                    /* RETURN  */
  YYSYMBOL_FOR = 21,                       /* FOR  */
  YYSYMBOL_IF = 22,                        /* IF  */
  YYSYMBOL_WHILE = 23,                     /* WHILE  */
  YYSYMBOL_SQRT = 24,                      /* SQRT  */
  YYSYMBOL_SCALE = 25,                     /* SCALE  */
  YYSYMBOL_IBASE = 26,                     /* IBASE  */
  YYSYMBOL_OBASE = 27,                     /* OBASE  */
  YYSYMBOL_AUTO = 28,                      /* AUTO  */
  YYSYMBOL_CONTINUE = 29,                  /* CONTINUE  */
  YYSYMBOL_ELSE = 30,                      /* ELSE  */
  YYSYMBOL_PRINT = 31,                     /* PRINT  */
  YYSYMBOL_BOOL_OR = 32,                   /* BOOL_OR  */
  YYSYMBOL_BOOL_AND = 33,                  /* BOOL_AND  */
  YYSYMBOL_BOOL_NOT = 34,                  /* BOOL_NOT  */
  YYSYMBOL_EQUALS = 35,                    /* EQUALS  */
  YYSYMBOL_LESS_EQ = 36,                   /* LESS_EQ  */
  YYSYMBOL_GREATER_EQ = 37,                /* GREATER_EQ  */
  YYSYMBOL_UNEQUALS = 38,                  /* UNEQUALS  */
  YYSYMBOL_LESS = 39,                      /* LESS  */
  YYSYMBOL_GREATER = 40,                   /* GREATER  */
  YYSYMBOL_ASSIGN_OP = 41,                 /* ASSIGN_OP  */
  YYSYMBOL_PLUS = 42,                      /* PLUS  */
  YYSYMBOL_MINUS = 43,                     /* MINUS  */
  YYSYMBOL_MULTIPLY = 44,                  /* MULTIPLY  */
  YYSYMBOL_DIVIDE = 45,                    /* DIVIDE  */
  YYSYMBOL_REMAINDER = 46,                 /* REMAINDER  */
  YYSYMBOL_EXPONENT = 47,                  /* EXPONENT  */
  YYSYMBOL_UMINUS = 48,                    /* UMINUS  */
  YYSYMBOL_INCR = 49,                      /* INCR  */
  YYSYMBOL_DECR = 50,                      /* DECR  */
  YYSYMBOL_YYACCEPT = 51,                  /* $accept  */
  YYSYMBOL_program = 52,                   /* program  */
  YYSYMBOL_input_item = 53,                /* input_item  */
  YYSYMBOL_semicolon_list = 54,            /* semicolon_list  */
  YYSYMBOL_statement_list = 55,            /* statement_list  */
  YYSYMBOL_opt_statement = 56,             /* opt_statement  */
  YYSYMBOL_statement = 57,                 /* statement  */
  YYSYMBOL_alloc_macro = 58,               /* alloc_macro  */
  YYSYMBOL_pop_nesting = 59,               /* pop_nesting  */
  YYSYMBOL_function = 60,                  /* function  */
  YYSYMBOL_function_header = 61,           /* function_header  */
  YYSYMBOL_opt_newline = 62,               /* opt_newline  */
  YYSYMBOL_opt_parameter_list = 63,        /* opt_parameter_list  */
  YYSYMBOL_parameter_list = 64,            /* parameter_list  */
  YYSYMBOL_opt_auto_define_list = 65,      /* opt_auto_define_list  */
  YYSYMBOL_define_list = 66,               /* define_list  */
  YYSYMBOL_opt_argument_list = 67,         /* opt_argument_list  */
  YYSYMBOL_argument_list = 68,             /* argument_list  */
  YYSYMBOL_opt_relational_expression = 69, /* opt_relational_expression  */
  YYSYMBOL_relational_expression = 70,     /* relational_expression  */
  YYSYMBOL_return_expression = 71,         /* return_expression  */
  YYSYMBOL_opt_expression = 72,            /* opt_expression  */
  YYSYMBOL_expression = 73,                /* expression  */
  YYSYMBOL_named_expression = 74,          /* named_expression  */
  YYSYMBOL_print_expression_list = 75,     /* print_expression_list  */
  YYSYMBOL_print_expression = 76           /* print_expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   682

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  51
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  26
/* YYNRULES -- Number of rules.  */
#define YYNRULES  108
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  198

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   305


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   193,   193,   194,   197,   205,   211,   215,   222,   225,
     226,   230,   234,   237,   238,   239,   243,   244,   252,   255,
     258,   262,   271,   276,   288,   300,   312,   320,   337,   343,
     351,   363,   367,   374,   394,   399,   413,   425,   426,   430,
     431,   435,   440,   445,   450,   460,   461,   462,   466,   471,
     476,   481,   491,   494,   498,   499,   503,   513,   516,   520,
     524,   528,   532,   536,   540,   544,   553,   557,   562,   571,
     574,   577,   581,   584,   588,   592,   599,   604,   608,   612,
     616,   620,   624,   628,   633,   638,   643,   648,   657,   661,
     665,   669,   673,   679,   685,   689,   693,   697,   701,   705,
     712,   720,   728,   733,   738,   746,   747,   753,   757
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "COMMA", "SEMICOLON",
  "LPAR", "RPAR", "LBRACE", "RBRACE", "LBRACKET", "RBRACKET", "DOT",
  "NEWLINE", "LETTER", "NUMBER", "STRING", "DEFINE", "BREAK", "QUIT",
  "LENGTH", "RETURN", "FOR", "IF", "WHILE", "SQRT", "SCALE", "IBASE",
  "OBASE", "AUTO", "CONTINUE", "ELSE", "PRINT", "BOOL_OR", "BOOL_AND",
  "BOOL_NOT", "EQUALS", "LESS_EQ", "GREATER_EQ", "UNEQUALS", "LESS",
  "GREATER", "ASSIGN_OP", "PLUS", "MINUS", "MULTIPLY", "DIVIDE",
  "REMAINDER", "EXPONENT", "UMINUS", "INCR", "DECR", "$accept", "program",
  "input_item", "semicolon_list", "statement_list", "opt_statement",
  "statement", "alloc_macro", "pop_nesting", "function", "function_header",
  "opt_newline", "opt_parameter_list", "parameter_list",
  "opt_auto_define_list", "define_list", "opt_argument_list",
  "argument_list", "opt_relational_expression", "relational_expression",
  "return_expression", "opt_expression", "expression", "named_expression",
  "print_expression_list", "print_expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-154)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-100)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -154,   215,  -154,    24,   336,   255,  -154,    32,  -154,  -154,
       4,  -154,  -154,     7,   363,    16,    39,    48,    60,    62,
    -154,  -154,  -154,   282,   336,   336,    -7,    -7,  -154,    12,
    -154,  -154,    19,   482,   -27,  -154,  -154,    74,   -10,    47,
    -154,   336,   336,    73,   336,   131,  -154,   482,  -154,  -154,
    -154,   336,   336,  -154,   482,    58,  -154,   622,  -154,    43,
    -154,  -154,  -154,   255,  -154,    81,    85,    89,  -154,  -154,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,  -154,  -154,  -154,   336,   255,  -154,   255,
      92,    96,   482,   466,  -154,   412,  -154,   336,  -154,   336,
     428,   447,   282,  -154,    90,    83,    88,  -154,  -154,   635,
     635,   635,   635,   635,   635,    37,    37,    55,    55,    55,
      55,     3,    27,  -154,  -154,  -154,   390,  -154,  -154,   101,
     482,   336,   102,   498,  -154,  -154,  -154,  -154,  -154,   108,
     126,   336,   336,    49,   482,   336,   134,   255,   336,   336,
     336,   336,   336,   336,   129,   133,   609,   622,   309,   143,
    -154,   255,  -154,  -154,   514,   530,   546,   562,   578,   594,
     120,  -154,  -154,   336,   122,  -154,   140,   255,   153,  -154,
     152,    31,    56,   255,  -154,   154,   149,  -154,  -154,  -154,
    -154,   255,  -154,   157,  -154,  -154,   158,  -154
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,     0,    12,    72,   100,    73,    22,
       0,    23,    25,     0,    66,     0,     0,     0,     0,   102,
     103,   104,    24,     0,     0,     0,     0,     0,     3,     0,
       9,     5,    39,    20,    71,     6,     7,     0,    71,     0,
      13,    52,     0,     0,     0,     0,    26,    67,    33,    33,
      33,     0,     0,   108,   107,    32,   105,    91,    76,   100,
     102,    83,    84,    11,     4,    41,     0,    40,    33,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    85,    86,    74,     0,    16,    31,    14,
       0,    53,    54,     0,    36,     0,    68,    69,    34,     0,
       0,     0,     0,    10,     0,    37,     0,    34,    34,    94,
      97,    99,    95,    96,    98,    77,    78,    79,    80,    81,
      82,    87,    87,    17,    15,    75,     0,   101,    88,     0,
      70,     0,     0,    65,    89,    90,   106,    42,    38,     0,
      43,     0,     0,   100,    55,    57,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,    93,    92,     0,     0,
      58,    18,    34,    19,    59,    62,    64,    60,    61,    63,
      45,    44,    56,    69,    28,    30,     0,    12,     0,    33,
      48,     0,     0,    18,    34,     0,     0,    47,    46,    35,
      34,    18,    49,    50,    27,    29,     0,    51
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -154,  -154,  -154,  -154,   -14,  -153,     0,   -40,  -105,  -154,
    -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,  -154,  -118,
    -154,    -6,    52,    -1,  -154,    67
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,    28,    29,    39,   162,   163,    97,   131,    31,
      32,   139,    66,    67,   177,   181,    90,    91,   159,   132,
      46,   129,    33,    38,    55,    56
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      34,    30,   141,   142,    34,    40,    59,   -21,   174,    98,
      99,   -21,    44,   146,    82,   -21,    63,    43,    60,    20,
      21,    48,    83,    84,    64,    61,    62,   160,   107,   108,
     190,    86,    65,   -21,   186,   187,    35,    41,   195,    83,
      84,    42,    36,   188,    49,    76,    77,    78,    79,    80,
      81,    87,    42,    50,    41,    88,    37,   175,   158,    89,
      87,   102,    34,   103,   189,    51,    47,    52,    89,    76,
      77,    78,    79,    80,    81,    54,    57,    58,    94,   191,
      85,    78,    79,    80,    81,   194,    34,   123,    34,   124,
     104,   105,   106,    92,    93,   138,    95,    37,   125,   126,
     137,   140,    81,   100,   101,   145,    68,    69,   147,    70,
      71,    72,    73,    74,    75,   154,    76,    77,    78,    79,
      80,    81,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   155,     4,    96,   122,   184,
     161,   170,     6,   171,     7,     8,    34,   173,   176,   130,
      13,   133,   179,   180,    54,    18,    19,    20,    21,   183,
      34,   185,   193,   182,   192,    24,   196,   178,   197,   136,
       0,     0,     0,     0,    25,     0,    34,    40,   144,     0,
      26,    27,    34,   133,     0,     0,     0,     0,     0,     0,
      34,     0,     0,   156,   157,     0,     0,   133,     0,     0,
     164,   165,   166,   167,   168,   169,     0,     0,     0,     0,
      93,     0,     0,     0,     0,     2,     3,     0,     0,    -8,
       4,     0,     5,     0,     0,   130,     6,    -8,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,     0,    22,     0,    23,     0,     0,    24,
       0,     0,     0,     0,     0,     0,     0,     0,    25,     0,
       4,     0,     5,     0,    26,    27,     6,     0,     7,     8,
       9,     0,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,     0,    22,     0,    23,     4,     0,    24,
       0,     0,     0,     6,     0,     7,     8,    53,    25,     0,
       0,    13,     0,     0,    26,    27,    18,    19,    20,    21,
       0,     0,     0,     0,     4,     0,    24,     0,     0,   172,
       6,     0,     7,     8,     0,    25,     0,     0,    13,     0,
       0,    26,    27,    18,    19,    20,    21,     0,     0,     0,
       0,     4,     0,    24,     0,     0,     0,     6,     0,     7,
       8,     0,    25,     0,     0,    13,     0,     0,    26,    27,
      18,    19,    20,    21,     0,     0,     0,     0,    45,     0,
      24,     0,     0,     0,     6,     0,     7,     8,     0,    25,
       0,     0,    13,     0,     0,    26,    27,    18,    19,    20,
      21,     0,     0,     0,     0,     4,     0,    24,     0,     0,
       0,     6,     0,   143,     8,     0,    25,     0,     0,    13,
       0,     0,    26,    27,    18,    19,    20,    21,   128,     0,
       0,     0,     0,     0,    24,     0,     0,     0,     0,     0,
       0,     0,     0,    25,   134,     0,     0,     0,     0,    26,
      27,     0,     0,     0,    68,    69,     0,    70,    71,    72,
      73,    74,    75,   135,    76,    77,    78,    79,    80,    81,
      68,    69,     0,    70,    71,    72,    73,    74,    75,     0,
      76,    77,    78,    79,    80,    81,   127,     0,     0,    68,
      69,     0,    70,    71,    72,    73,    74,    75,     0,    76,
      77,    78,    79,    80,    81,     0,     0,     0,    68,    69,
       0,    70,    71,    72,    73,    74,    75,     0,    76,    77,
      78,    79,    80,    81,    68,    69,     0,    70,    71,    72,
      73,    74,    75,     0,    76,    77,    78,    79,    80,    81,
      68,    69,     0,   148,   149,   150,   151,   152,   153,     0,
      76,    77,    78,    79,    80,    81,   -94,   -94,     0,  -100,
    -100,  -100,  -100,  -100,  -100,     0,    76,    77,    78,    79,
      80,    81,   -97,   -97,     0,  -100,  -100,  -100,  -100,  -100,
    -100,     0,    76,    77,    78,    79,    80,    81,   -99,   -99,
       0,  -100,  -100,  -100,  -100,  -100,  -100,     0,    76,    77,
      78,    79,    80,    81,   -95,   -95,     0,  -100,  -100,  -100,
    -100,  -100,  -100,     0,    76,    77,    78,    79,    80,    81,
     -96,   -96,     0,  -100,  -100,  -100,  -100,  -100,  -100,     0,
      76,    77,    78,    79,    80,    81,   -98,   -98,     0,  -100,
    -100,  -100,  -100,  -100,  -100,     0,    76,    77,    78,    79,
      80,    81,    69,     0,    70,    71,    72,    73,    74,    75,
       0,    76,    77,    78,    79,    80,    81,    70,    71,    72,
      73,    74,    75,     0,    76,    77,    78,    79,    80,    81,
    -100,  -100,  -100,  -100,  -100,  -100,     0,    76,    77,    78,
      79,    80,    81
};

static const yytype_int16 yycheck[] =
{
       1,     1,   107,   108,     5,     5,    13,     4,   161,    49,
      50,     8,     5,   131,    41,    12,     4,    13,    25,    26,
      27,     5,    49,    50,    12,    26,    27,   145,    68,    69,
     183,    41,    13,    30,     3,     4,    12,     5,   191,    49,
      50,     9,    18,    12,     5,    42,    43,    44,    45,    46,
      47,     4,     9,     5,     5,     8,     4,   162,     9,    12,
       4,     3,    63,    63,     8,     5,    14,     5,    12,    42,
      43,    44,    45,    46,    47,    23,    24,    25,     5,   184,
       6,    44,    45,    46,    47,   190,    87,    87,    89,    89,
       9,     6,     3,    41,    42,    12,    44,    45,     6,     3,
      10,    13,    47,    51,    52,     4,    32,    33,     6,    35,
      36,    37,    38,    39,    40,     7,    42,    43,    44,    45,
      46,    47,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,     9,     5,     6,    86,   179,
       6,    12,    11,    10,    13,    14,   147,     4,    28,    97,
      19,    99,    30,    13,   102,    24,    25,    26,    27,     6,
     161,     9,    13,   177,    10,    34,     9,   173,    10,   102,
      -1,    -1,    -1,    -1,    43,    -1,   177,   177,   126,    -1,
      49,    50,   183,   131,    -1,    -1,    -1,    -1,    -1,    -1,
     191,    -1,    -1,   141,   142,    -1,    -1,   145,    -1,    -1,
     148,   149,   150,   151,   152,   153,    -1,    -1,    -1,    -1,
     158,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,     4,
       5,    -1,     7,    -1,    -1,   173,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    -1,    31,    -1,    -1,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
       5,    -1,     7,    -1,    49,    50,    11,    -1,    13,    14,
      15,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    -1,    31,     5,    -1,    34,
      -1,    -1,    -1,    11,    -1,    13,    14,    15,    43,    -1,
      -1,    19,    -1,    -1,    49,    50,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,     5,    -1,    34,    -1,    -1,    10,
      11,    -1,    13,    14,    -1,    43,    -1,    -1,    19,    -1,
      -1,    49,    50,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,     5,    -1,    34,    -1,    -1,    -1,    11,    -1,    13,
      14,    -1,    43,    -1,    -1,    19,    -1,    -1,    49,    50,
      24,    25,    26,    27,    -1,    -1,    -1,    -1,     5,    -1,
      34,    -1,    -1,    -1,    11,    -1,    13,    14,    -1,    43,
      -1,    -1,    19,    -1,    -1,    49,    50,    24,    25,    26,
      27,    -1,    -1,    -1,    -1,     5,    -1,    34,    -1,    -1,
      -1,    11,    -1,    13,    14,    -1,    43,    -1,    -1,    19,
      -1,    -1,    49,    50,    24,    25,    26,    27,     6,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,     6,    -1,    -1,    -1,    -1,    49,
      50,    -1,    -1,    -1,    32,    33,    -1,    35,    36,    37,
      38,    39,    40,     6,    42,    43,    44,    45,    46,    47,
      32,    33,    -1,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    10,    -1,    -1,    32,
      33,    -1,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    -1,    -1,    -1,    32,    33,
      -1,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    32,    33,    -1,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      32,    33,    -1,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    32,    33,    -1,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    32,    33,    -1,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    32,    33,
      -1,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    47,    32,    33,    -1,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      32,    33,    -1,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    32,    33,    -1,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    33,    -1,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    47,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    47
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    52,     0,     1,     5,     7,    11,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    29,    31,    34,    43,    49,    50,    53,    54,
      57,    60,    61,    73,    74,    12,    18,    73,    74,    55,
      57,     5,     9,    13,     5,     5,    71,    73,     5,     5,
       5,     5,     5,    15,    73,    75,    76,    73,    73,    13,
      25,    74,    74,     4,    12,    13,    63,    64,    32,    33,
      35,    36,    37,    38,    39,    40,    42,    43,    44,    45,
      46,    47,    41,    49,    50,     6,    41,     4,     8,    12,
      67,    68,    73,    73,     5,    73,     6,    58,    58,    58,
      73,    73,     3,    57,     9,     6,     3,    58,    58,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    57,    57,     6,     3,    10,     6,    72,
      73,    59,    70,    73,     6,     6,    76,    10,    12,    62,
      13,    59,    59,    13,    73,     4,    70,     6,    35,    36,
      37,    38,    39,    40,     7,     9,    73,    73,     9,    69,
      70,     6,    56,    57,    73,    73,    73,    73,    73,    73,
      12,    10,    10,     4,    56,    59,    28,    65,    72,    30,
      13,    66,    55,     6,    58,     9,     3,     4,    12,     8,
      56,    59,    10,    13,    59,    56,     9,    10
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    51,    52,    52,    53,    53,    53,    53,    54,    54,
      54,    54,    55,    55,    55,    55,    55,    55,    56,    56,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    58,    59,    60,    61,    62,    62,    63,
      63,    64,    64,    64,    64,    65,    65,    65,    66,    66,
      66,    66,    67,    67,    68,    68,    68,    69,    69,    70,
      70,    70,    70,    70,    70,    70,    71,    71,    71,    72,
      72,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      74,    74,    74,    74,    74,    75,    75,    76,    76
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     2,     2,     0,     1,
       3,     2,     0,     1,     2,     3,     2,     3,     0,     1,
       1,     3,     1,     1,     1,     1,     2,    11,     7,    11,
       7,     3,     2,     0,     0,     9,     3,     0,     1,     0,
       1,     1,     3,     3,     5,     0,     3,     3,     1,     3,
       3,     5,     0,     1,     1,     3,     5,     0,     1,     3,
       3,     3,     3,     3,     3,     1,     0,     1,     2,     0,
       1,     1,     1,     1,     3,     4,     2,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     2,     3,     4,     4,
       4,     2,     5,     5,     3,     3,     3,     3,     3,     3,
       1,     4,     1,     1,     1,     1,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* input_item: semicolon_list NEWLINE  */
#line 198 "../src/bc/bc.y"
                        {
				emit((yyvsp[-1].node), 0);
				macro_char = reset_macro_char;
				putchar('\n');
				free_tree();
				st_has_continue = false;
			}
#line 1513 "src/bc/bc.p/bc.c"
    break;

  case 5: /* input_item: function  */
#line 206 "../src/bc/bc.y"
                        {
				putchar('\n');
				free_tree();
				st_has_continue = false;
			}
#line 1523 "src/bc/bc.p/bc.c"
    break;

  case 6: /* input_item: error NEWLINE  */
#line 212 "../src/bc/bc.y"
                        {
				yyerrok;
			}
#line 1531 "src/bc/bc.p/bc.c"
    break;

  case 7: /* input_item: error QUIT  */
#line 216 "../src/bc/bc.y"
                        {
				yyerrok;
			}
#line 1539 "src/bc/bc.p/bc.c"
    break;

  case 8: /* semicolon_list: %empty  */
#line 222 "../src/bc/bc.y"
                        {
				(yyval.node) = cs("");
			}
#line 1547 "src/bc/bc.p/bc.c"
    break;

  case 10: /* semicolon_list: semicolon_list SEMICOLON statement  */
#line 227 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), END_NODE);
			}
#line 1555 "src/bc/bc.p/bc.c"
    break;

  case 12: /* statement_list: %empty  */
#line 234 "../src/bc/bc.y"
                        {
				(yyval.node) = cs("");
			}
#line 1563 "src/bc/bc.p/bc.c"
    break;

  case 15: /* statement_list: statement_list NEWLINE statement  */
#line 240 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), END_NODE);
			}
#line 1571 "src/bc/bc.p/bc.c"
    break;

  case 17: /* statement_list: statement_list SEMICOLON statement  */
#line 245 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), END_NODE);
			}
#line 1579 "src/bc/bc.p/bc.c"
    break;

  case 18: /* opt_statement: %empty  */
#line 252 "../src/bc/bc.y"
                        {
				(yyval.node) = cs("");
			}
#line 1587 "src/bc/bc.p/bc.c"
    break;

  case 20: /* statement: expression  */
#line 259 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), cs("ps."), END_NODE);
			}
#line 1595 "src/bc/bc.p/bc.c"
    break;

  case 21: /* statement: named_expression ASSIGN_OP expression  */
#line 263 "../src/bc/bc.y"
                        {
				if ((yyvsp[-1].str)[0] == '\0')
					(yyval.node) = node((yyvsp[0].node), cs((yyvsp[-1].str)), (yyvsp[-2].lvalue).store,
					    END_NODE);
				else
					(yyval.node) = node((yyvsp[-2].lvalue).load, (yyvsp[0].node), cs((yyvsp[-1].str)), (yyvsp[-2].lvalue).store,
					    END_NODE);
			}
#line 1608 "src/bc/bc.p/bc.c"
    break;

  case 22: /* statement: STRING  */
#line 272 "../src/bc/bc.y"
                        {
				(yyval.node) = node(cs("["), as((yyvsp[0].str)),
				    cs("]P"), END_NODE);
			}
#line 1617 "src/bc/bc.p/bc.c"
    break;

  case 23: /* statement: BREAK  */
#line 277 "../src/bc/bc.y"
                        {
				if (breaksp == 0) {
					warning("break not in for or while");
					YYERROR;
				} else {
					(yyval.node) = node(
					    numnode(nesting -
						breakstack[breaksp-1]),
					    cs("Q"), END_NODE);
				}
			}
#line 1633 "src/bc/bc.p/bc.c"
    break;

  case 24: /* statement: CONTINUE  */
#line 289 "../src/bc/bc.y"
                        {
				if (breaksp == 0) {
					warning("continue not in for or while");
					YYERROR;
				} else {
					st_has_continue = true;
					(yyval.node) = node(numnode(nesting -
					    breakstack[breaksp-1] - 1),
					    cs("J"), END_NODE);
				}
			}
#line 1649 "src/bc/bc.p/bc.c"
    break;

  case 25: /* statement: QUIT  */
#line 301 "../src/bc/bc.y"
                        {
				sigset_t mask;

				putchar('q');
				fflush(stdout);
				if (dc) {
					sigprocmask(SIG_BLOCK, NULL, &mask);
					sigsuspend(&mask);
				} else
					exit(0);
			}
#line 1665 "src/bc/bc.p/bc.c"
    break;

  case 26: /* statement: RETURN return_expression  */
#line 313 "../src/bc/bc.y"
                        {
				if (nesting == 0) {
					warning("return must be in a function");
					YYERROR;
				}
				(yyval.node) = (yyvsp[0].node);
			}
#line 1677 "src/bc/bc.p/bc.c"
    break;

  case 27: /* statement: FOR LPAR alloc_macro opt_expression SEMICOLON opt_relational_expression SEMICOLON opt_expression RPAR opt_statement pop_nesting  */
#line 323 "../src/bc/bc.y"
                        {
				ssize_t n;

				if (st_has_continue)
					n = node((yyvsp[-1].node), cs("M"), (yyvsp[-3].node), cs("s."),
					    (yyvsp[-5].node), (yyvsp[-8].node), END_NODE);
				else
					n = node((yyvsp[-1].node), (yyvsp[-3].node), cs("s."), (yyvsp[-5].node), (yyvsp[-8].node),
					    END_NODE);

				emit_macro((yyvsp[-8].node), n);
				(yyval.node) = node((yyvsp[-7].node), cs("s."), (yyvsp[-5].node), (yyvsp[-8].node), cs(" "),
				    END_NODE);
			}
#line 1696 "src/bc/bc.p/bc.c"
    break;

  case 28: /* statement: IF LPAR alloc_macro pop_nesting relational_expression RPAR opt_statement  */
#line 339 "../src/bc/bc.y"
                        {
				emit_macro((yyvsp[-4].node), (yyvsp[0].node));
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[-4].node), cs(" "), END_NODE);
			}
#line 1705 "src/bc/bc.p/bc.c"
    break;

  case 29: /* statement: IF LPAR alloc_macro pop_nesting relational_expression RPAR opt_statement ELSE alloc_macro pop_nesting opt_statement  */
#line 345 "../src/bc/bc.y"
                        {
				emit_macro((yyvsp[-8].node), (yyvsp[-4].node));
				emit_macro((yyvsp[-2].node), (yyvsp[0].node));
				(yyval.node) = node((yyvsp[-6].node), (yyvsp[-8].node), cs("e"), (yyvsp[-2].node), cs(" "),
				    END_NODE);
			}
#line 1716 "src/bc/bc.p/bc.c"
    break;

  case 30: /* statement: WHILE LPAR alloc_macro relational_expression RPAR opt_statement pop_nesting  */
#line 353 "../src/bc/bc.y"
                        {
				ssize_t n;

				if (st_has_continue)
					n = node((yyvsp[-1].node), cs("M"), (yyvsp[-3].node), (yyvsp[-4].node), END_NODE);
				else
					n = node((yyvsp[-1].node), (yyvsp[-3].node), (yyvsp[-4].node), END_NODE);
				emit_macro((yyvsp[-4].node), n);
				(yyval.node) = node((yyvsp[-3].node), (yyvsp[-4].node), cs(" "), END_NODE);
			}
#line 1731 "src/bc/bc.p/bc.c"
    break;

  case 31: /* statement: LBRACE statement_list RBRACE  */
#line 364 "../src/bc/bc.y"
                        {
				(yyval.node) = (yyvsp[-1].node);
			}
#line 1739 "src/bc/bc.p/bc.c"
    break;

  case 32: /* statement: PRINT print_expression_list  */
#line 368 "../src/bc/bc.y"
                        {
				(yyval.node) = (yyvsp[0].node);
			}
#line 1747 "src/bc/bc.p/bc.c"
    break;

  case 33: /* alloc_macro: %empty  */
#line 374 "../src/bc/bc.y"
                        {
				(yyval.node) = cs(str_table[macro_char]);
				macro_char++;
				/* Do not use [, \ and ] */
				if (macro_char == '[')
					macro_char += 3;
				/* skip letters */
				else if (macro_char == 'a')
					macro_char = '{';
				else if (macro_char == ARRAY_CHAR)
					macro_char += 26;
				else if (macro_char == 255)
					fatal("program too big");
				if (breaksp == BREAKSTACK_SZ)
					fatal("nesting too deep");
				breakstack[breaksp++] = nesting++;
			}
#line 1769 "src/bc/bc.p/bc.c"
    break;

  case 34: /* pop_nesting: %empty  */
#line 394 "../src/bc/bc.y"
                        {
				breaksp--;
			}
#line 1777 "src/bc/bc.p/bc.c"
    break;

  case 35: /* function: function_header opt_parameter_list RPAR opt_newline LBRACE NEWLINE opt_auto_define_list statement_list RBRACE  */
#line 402 "../src/bc/bc.y"
                        {
				int n = node(prologue, (yyvsp[-1].node), epilogue,
				    cs("0"), numnode(nesting),
				    cs("Q"), END_NODE);
				emit_macro((yyvsp[-8].node), n);
				reset_macro_char = macro_char;
				nesting = 0;
				breaksp = 0;
			}
#line 1791 "src/bc/bc.p/bc.c"
    break;

  case 36: /* function_header: DEFINE LETTER LPAR  */
#line 414 "../src/bc/bc.y"
                        {
				(yyval.node) = function_node((yyvsp[-1].astr));
				free((yyvsp[-1].astr));
				prologue = cs("");
				epilogue = cs("");
				nesting = 1;
				breaksp = 0;
				breakstack[breaksp] = 0;
			}
#line 1805 "src/bc/bc.p/bc.c"
    break;

  case 41: /* parameter_list: LETTER  */
#line 436 "../src/bc/bc.y"
                        {
				add_par(letter_node((yyvsp[0].astr)));
				free((yyvsp[0].astr));
			}
#line 1814 "src/bc/bc.p/bc.c"
    break;

  case 42: /* parameter_list: LETTER LBRACKET RBRACKET  */
#line 441 "../src/bc/bc.y"
                        {
				add_par(array_node((yyvsp[-2].astr)));
				free((yyvsp[-2].astr));
			}
#line 1823 "src/bc/bc.p/bc.c"
    break;

  case 43: /* parameter_list: parameter_list COMMA LETTER  */
#line 446 "../src/bc/bc.y"
                        {
				add_par(letter_node((yyvsp[0].astr)));
				free((yyvsp[0].astr));
			}
#line 1832 "src/bc/bc.p/bc.c"
    break;

  case 44: /* parameter_list: parameter_list COMMA LETTER LBRACKET RBRACKET  */
#line 451 "../src/bc/bc.y"
                        {
				add_par(array_node((yyvsp[-2].astr)));
				free((yyvsp[-2].astr));
			}
#line 1841 "src/bc/bc.p/bc.c"
    break;

  case 48: /* define_list: LETTER  */
#line 467 "../src/bc/bc.y"
                        {
				add_local(letter_node((yyvsp[0].astr)));
				free((yyvsp[0].astr));
			}
#line 1850 "src/bc/bc.p/bc.c"
    break;

  case 49: /* define_list: LETTER LBRACKET RBRACKET  */
#line 472 "../src/bc/bc.y"
                        {
				add_local(array_node((yyvsp[-2].astr)));
				free((yyvsp[-2].astr));
			}
#line 1859 "src/bc/bc.p/bc.c"
    break;

  case 50: /* define_list: define_list COMMA LETTER  */
#line 477 "../src/bc/bc.y"
                        {
				add_local(letter_node((yyvsp[0].astr)));
				free((yyvsp[0].astr));
			}
#line 1868 "src/bc/bc.p/bc.c"
    break;

  case 51: /* define_list: define_list COMMA LETTER LBRACKET RBRACKET  */
#line 482 "../src/bc/bc.y"
                        {
				add_local(array_node((yyvsp[-2].astr)));
				free((yyvsp[-2].astr));
			}
#line 1877 "src/bc/bc.p/bc.c"
    break;

  case 52: /* opt_argument_list: %empty  */
#line 491 "../src/bc/bc.y"
                        {
				(yyval.node) = cs("");
			}
#line 1885 "src/bc/bc.p/bc.c"
    break;

  case 55: /* argument_list: argument_list COMMA expression  */
#line 500 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), END_NODE);
			}
#line 1893 "src/bc/bc.p/bc.c"
    break;

  case 56: /* argument_list: argument_list COMMA LETTER LBRACKET RBRACKET  */
#line 504 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-4].node), cs("l"), array_node((yyvsp[-2].astr)),
				    END_NODE);
				free((yyvsp[-2].astr));
			}
#line 1903 "src/bc/bc.p/bc.c"
    break;

  case 57: /* opt_relational_expression: %empty  */
#line 513 "../src/bc/bc.y"
                        {
				(yyval.node) = cs(" 0 0=");
			}
#line 1911 "src/bc/bc.p/bc.c"
    break;

  case 59: /* relational_expression: expression EQUALS expression  */
#line 521 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("="), END_NODE);
			}
#line 1919 "src/bc/bc.p/bc.c"
    break;

  case 60: /* relational_expression: expression UNEQUALS expression  */
#line 525 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("!="), END_NODE);
			}
#line 1927 "src/bc/bc.p/bc.c"
    break;

  case 61: /* relational_expression: expression LESS expression  */
#line 529 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs(">"), END_NODE);
			}
#line 1935 "src/bc/bc.p/bc.c"
    break;

  case 62: /* relational_expression: expression LESS_EQ expression  */
#line 533 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("!<"), END_NODE);
			}
#line 1943 "src/bc/bc.p/bc.c"
    break;

  case 63: /* relational_expression: expression GREATER expression  */
#line 537 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("<"), END_NODE);
			}
#line 1951 "src/bc/bc.p/bc.c"
    break;

  case 64: /* relational_expression: expression GREATER_EQ expression  */
#line 541 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("!>"), END_NODE);
			}
#line 1959 "src/bc/bc.p/bc.c"
    break;

  case 65: /* relational_expression: expression  */
#line 545 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), cs(" 0!="), END_NODE);
			}
#line 1967 "src/bc/bc.p/bc.c"
    break;

  case 66: /* return_expression: %empty  */
#line 553 "../src/bc/bc.y"
                        {
				(yyval.node) = node(cs("0"), epilogue,
				    numnode(nesting), cs("Q"), END_NODE);
			}
#line 1976 "src/bc/bc.p/bc.c"
    break;

  case 67: /* return_expression: expression  */
#line 558 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), epilogue,
				    numnode(nesting), cs("Q"), END_NODE);
			}
#line 1985 "src/bc/bc.p/bc.c"
    break;

  case 68: /* return_expression: LPAR RPAR  */
#line 563 "../src/bc/bc.y"
                        {
				(yyval.node) = node(cs("0"), epilogue,
				    numnode(nesting), cs("Q"), END_NODE);
			}
#line 1994 "src/bc/bc.p/bc.c"
    break;

  case 69: /* opt_expression: %empty  */
#line 571 "../src/bc/bc.y"
                        {
				(yyval.node) = cs(" 0");
			}
#line 2002 "src/bc/bc.p/bc.c"
    break;

  case 71: /* expression: named_expression  */
#line 578 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].lvalue).load, END_NODE);
			}
#line 2010 "src/bc/bc.p/bc.c"
    break;

  case 72: /* expression: DOT  */
#line 581 "../src/bc/bc.y"
                        {
				(yyval.node) = node(cs("l."), END_NODE);
			}
#line 2018 "src/bc/bc.p/bc.c"
    break;

  case 73: /* expression: NUMBER  */
#line 585 "../src/bc/bc.y"
                        {
				(yyval.node) = node(cs(" "), as((yyvsp[0].str)), END_NODE);
			}
#line 2026 "src/bc/bc.p/bc.c"
    break;

  case 74: /* expression: LPAR expression RPAR  */
#line 589 "../src/bc/bc.y"
                        {
				(yyval.node) = (yyvsp[-1].node);
			}
#line 2034 "src/bc/bc.p/bc.c"
    break;

  case 75: /* expression: LETTER LPAR opt_argument_list RPAR  */
#line 593 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-1].node), cs("l"),
				    function_node((yyvsp[-3].astr)), cs("x"),
				    END_NODE);
				free((yyvsp[-3].astr));
			}
#line 2045 "src/bc/bc.p/bc.c"
    break;

  case 76: /* expression: MINUS expression  */
#line 600 "../src/bc/bc.y"
                        {
				(yyval.node) = node(cs(" 0"), (yyvsp[0].node), cs("-"),
				    END_NODE);
			}
#line 2054 "src/bc/bc.p/bc.c"
    break;

  case 77: /* expression: expression PLUS expression  */
#line 605 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("+"), END_NODE);
			}
#line 2062 "src/bc/bc.p/bc.c"
    break;

  case 78: /* expression: expression MINUS expression  */
#line 609 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("-"), END_NODE);
			}
#line 2070 "src/bc/bc.p/bc.c"
    break;

  case 79: /* expression: expression MULTIPLY expression  */
#line 613 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("*"), END_NODE);
			}
#line 2078 "src/bc/bc.p/bc.c"
    break;

  case 80: /* expression: expression DIVIDE expression  */
#line 617 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("/"), END_NODE);
			}
#line 2086 "src/bc/bc.p/bc.c"
    break;

  case 81: /* expression: expression REMAINDER expression  */
#line 621 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("%"), END_NODE);
			}
#line 2094 "src/bc/bc.p/bc.c"
    break;

  case 82: /* expression: expression EXPONENT expression  */
#line 625 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("^"), END_NODE);
			}
#line 2102 "src/bc/bc.p/bc.c"
    break;

  case 83: /* expression: INCR named_expression  */
#line 629 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].lvalue).load, cs("1+d"), (yyvsp[0].lvalue).store,
				    END_NODE);
			}
#line 2111 "src/bc/bc.p/bc.c"
    break;

  case 84: /* expression: DECR named_expression  */
#line 634 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].lvalue).load, cs("1-d"),
				    (yyvsp[0].lvalue).store, END_NODE);
			}
#line 2120 "src/bc/bc.p/bc.c"
    break;

  case 85: /* expression: named_expression INCR  */
#line 639 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-1].lvalue).load, cs("d1+"),
				    (yyvsp[-1].lvalue).store, END_NODE);
			}
#line 2129 "src/bc/bc.p/bc.c"
    break;

  case 86: /* expression: named_expression DECR  */
#line 644 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-1].lvalue).load, cs("d1-"),
				    (yyvsp[-1].lvalue).store, END_NODE);
			}
#line 2138 "src/bc/bc.p/bc.c"
    break;

  case 87: /* expression: named_expression ASSIGN_OP expression  */
#line 649 "../src/bc/bc.y"
                        {
				if ((yyvsp[-1].str)[0] == '\0')
					(yyval.node) = node((yyvsp[0].node), cs((yyvsp[-1].str)), cs("d"), (yyvsp[-2].lvalue).store,
					    END_NODE);
				else
					(yyval.node) = node((yyvsp[-2].lvalue).load, (yyvsp[0].node), cs((yyvsp[-1].str)), cs("d"),
					    (yyvsp[-2].lvalue).store, END_NODE);
			}
#line 2151 "src/bc/bc.p/bc.c"
    break;

  case 88: /* expression: LENGTH LPAR expression RPAR  */
#line 658 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-1].node), cs("Z"), END_NODE);
			}
#line 2159 "src/bc/bc.p/bc.c"
    break;

  case 89: /* expression: SQRT LPAR expression RPAR  */
#line 662 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-1].node), cs("v"), END_NODE);
			}
#line 2167 "src/bc/bc.p/bc.c"
    break;

  case 90: /* expression: SCALE LPAR expression RPAR  */
#line 666 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-1].node), cs("X"), END_NODE);
			}
#line 2175 "src/bc/bc.p/bc.c"
    break;

  case 91: /* expression: BOOL_NOT expression  */
#line 670 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), cs("N"), END_NODE);
			}
#line 2183 "src/bc/bc.p/bc.c"
    break;

  case 92: /* expression: expression BOOL_AND alloc_macro pop_nesting expression  */
#line 674 "../src/bc/bc.y"
                        {
				ssize_t n = node(cs("R"), (yyvsp[0].node), END_NODE);
				emit_macro((yyvsp[-2].node), n);
				(yyval.node) = node((yyvsp[-4].node), cs("d0!="), (yyvsp[-2].node), END_NODE);
			}
#line 2193 "src/bc/bc.p/bc.c"
    break;

  case 93: /* expression: expression BOOL_OR alloc_macro pop_nesting expression  */
#line 680 "../src/bc/bc.y"
                        {
				ssize_t n = node(cs("R"), (yyvsp[0].node), END_NODE);
				emit_macro((yyvsp[-2].node), n);
				(yyval.node) = node((yyvsp[-4].node), cs("d0="), (yyvsp[-2].node), END_NODE);
			}
#line 2203 "src/bc/bc.p/bc.c"
    break;

  case 94: /* expression: expression EQUALS expression  */
#line 686 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("G"), END_NODE);
			}
#line 2211 "src/bc/bc.p/bc.c"
    break;

  case 95: /* expression: expression UNEQUALS expression  */
#line 690 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("GN"), END_NODE);
			}
#line 2219 "src/bc/bc.p/bc.c"
    break;

  case 96: /* expression: expression LESS expression  */
#line 694 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), (yyvsp[-2].node), cs("("), END_NODE);
			}
#line 2227 "src/bc/bc.p/bc.c"
    break;

  case 97: /* expression: expression LESS_EQ expression  */
#line 698 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), (yyvsp[-2].node), cs("{"), END_NODE);
			}
#line 2235 "src/bc/bc.p/bc.c"
    break;

  case 98: /* expression: expression GREATER expression  */
#line 702 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("("), END_NODE);
			}
#line 2243 "src/bc/bc.p/bc.c"
    break;

  case 99: /* expression: expression GREATER_EQ expression  */
#line 706 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), cs("{"), END_NODE);
			}
#line 2251 "src/bc/bc.p/bc.c"
    break;

  case 100: /* named_expression: LETTER  */
#line 713 "../src/bc/bc.y"
                        {
				(yyval.lvalue).load = node(cs("l"), letter_node((yyvsp[0].astr)),
				    END_NODE);
				(yyval.lvalue).store = node(cs("s"), letter_node((yyvsp[0].astr)),
				    END_NODE);
				free((yyvsp[0].astr));
			}
#line 2263 "src/bc/bc.p/bc.c"
    break;

  case 101: /* named_expression: LETTER LBRACKET expression RBRACKET  */
#line 721 "../src/bc/bc.y"
                        {
				(yyval.lvalue).load = node((yyvsp[-1].node), cs(";"),
				    array_node((yyvsp[-3].astr)), END_NODE);
				(yyval.lvalue).store = node((yyvsp[-1].node), cs(":"),
				    array_node((yyvsp[-3].astr)), END_NODE);
				free((yyvsp[-3].astr));
			}
#line 2275 "src/bc/bc.p/bc.c"
    break;

  case 102: /* named_expression: SCALE  */
#line 729 "../src/bc/bc.y"
                        {
				(yyval.lvalue).load = cs("K");
				(yyval.lvalue).store = cs("k");
			}
#line 2284 "src/bc/bc.p/bc.c"
    break;

  case 103: /* named_expression: IBASE  */
#line 734 "../src/bc/bc.y"
                        {
				(yyval.lvalue).load = cs("I");
				(yyval.lvalue).store = cs("i");
			}
#line 2293 "src/bc/bc.p/bc.c"
    break;

  case 104: /* named_expression: OBASE  */
#line 739 "../src/bc/bc.y"
                        {
				(yyval.lvalue).load = cs("O");
				(yyval.lvalue).store = cs("o");
			}
#line 2302 "src/bc/bc.p/bc.c"
    break;

  case 106: /* print_expression_list: print_expression_list COMMA print_expression  */
#line 748 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[-2].node), (yyvsp[0].node), END_NODE);
			}
#line 2310 "src/bc/bc.p/bc.c"
    break;

  case 107: /* print_expression: expression  */
#line 754 "../src/bc/bc.y"
                        {
				(yyval.node) = node((yyvsp[0].node), cs("ds.n"), END_NODE);
			}
#line 2318 "src/bc/bc.p/bc.c"
    break;

  case 108: /* print_expression: STRING  */
#line 758 "../src/bc/bc.y"
                        {
				char *p = escape((yyvsp[0].str));
				(yyval.node) = node(cs("["), as(p), cs("]n"), END_NODE);
				free(p);
			}
#line 2328 "src/bc/bc.p/bc.c"
    break;


#line 2332 "src/bc/bc.p/bc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 763 "../src/bc/bc.y"



static void
grow(void)
{
	struct tree *p;
	size_t newsize;

	if (current == instr_sz) {
		newsize = instr_sz * 2 + 1;
		p = reallocarray(instructions, newsize, sizeof(*p));
		if (p == NULL) {
			free(instructions);
			err(1, NULL);
		}
		instructions = p;
		instr_sz = newsize;
	}
}

static ssize_t
cs(const char *str)
{

	grow();
	instructions[current].index = CONST_STRING;
	instructions[current].u.cstr = str;
	return (current++);
}

static ssize_t
as(const char *str)
{

	grow();
	instructions[current].index = ALLOC_STRING;
	instructions[current].u.astr = strdup(str);
	if (instructions[current].u.astr == NULL)
		err(1, NULL);
	return (current++);
}

static ssize_t
node(ssize_t arg, ...)
{
	va_list ap;
	ssize_t ret;

	va_start(ap, arg);

	ret = current;
	grow();
	instructions[current++].index = arg;

	do {
		arg = va_arg(ap, ssize_t);
		grow();
		instructions[current++].index = arg;
	} while (arg != END_NODE);

	va_end(ap);
	return (ret);
}

static void
emit(ssize_t i, int level)
{

	if (level > 1000)
		errx(1, "internal error: tree level > 1000");
	if (instructions[i].index >= 0) {
		while (instructions[i].index != END_NODE &&
		    instructions[i].index != i)  {
			emit(instructions[i].index, level + 1);
			i++;
		}
	} else if (instructions[i].index != END_NODE)
		fputs(instructions[i].u.cstr, stdout);
}

static void
emit_macro(int nodeidx, ssize_t code)
{

	putchar('[');
	emit(code, 0);
	printf("]s%s\n", instructions[nodeidx].u.cstr);
	nesting--;
}

static void
free_tree(void)
{
	ssize_t	i;

	for (i = 0; i < current; i++)
		if (instructions[i].index == ALLOC_STRING)
			free(instructions[i].u.astr);
	current = 0;
}

static ssize_t
numnode(int num)
{
	const char *p;

	if (num < 10)
		p = str_table['0' + num];
	else if (num < 16)
		p = str_table['A' - 10 + num];
	else
		errx(1, "internal error: break num > 15");
	return (node(cs(" "), cs(p), END_NODE));
}


static ssize_t
lookup(char * str, size_t len, char type)
{
	ENTRY entry, *found;
	u_char *p;
	u_short num;

	/* The scanner allocated an extra byte already */
	if (str[len-1] != type) {
		str[len] = type;
		str[len+1] = '\0';
	}
	entry.key = str;
	found = hsearch(entry, FIND);
	if (found == NULL) {
		if (var_count == MAX_VARIABLES)
			errx(1, "too many variables");
		p = malloc(4);
		if (p == NULL)
			err(1, NULL);
		num = var_count++;
		p[0] = 255;
		p[1] = ENCODE(num / VAR_BASE + 1);
		p[2] = ENCODE(num % VAR_BASE + 1);
		p[3] = '\0';

		entry.data = (char *)p;
		entry.key = strdup(str);
		if (entry.key == NULL)
			err(1, NULL);
		found = hsearch(entry, ENTER);
		if (found == NULL)
			err(1, NULL);
	}
	return (cs(found->data));
}

static ssize_t
letter_node(char *str)
{
	size_t len;

	len = strlen(str);
	if (len == 1 && str[0] != '_')
		return (cs(str_table[(int)str[0]]));
	else
		return (lookup(str, len, 'L'));
}

static ssize_t
array_node(char *str)
{
	size_t len;

	len = strlen(str);
	if (len == 1 && str[0] != '_')
		return (cs(str_table[(int)str[0] - 'a' + ARRAY_CHAR]));
	else
		return (lookup(str, len, 'A'));
}

static ssize_t
function_node(char *str)
{
	size_t len;

	len = strlen(str);
	if (len == 1 && str[0] != '_')
		return (cs(str_table[(int)str[0] - 'a' + FUNC_CHAR]));
	else
		return (lookup(str, len, 'F'));
}

static void
add_par(ssize_t n)
{

	prologue = node(cs("S"), n, prologue, END_NODE);
	epilogue = node(epilogue, cs("L"), n, cs("s."), END_NODE);
}

static void
add_local(ssize_t n)
{

	prologue = node(cs("0S"), n, prologue, END_NODE);
	epilogue = node(epilogue, cs("L"), n, cs("s."), END_NODE);
}

void
yyerror(const char *s)
{
	char *p, *str;
	int n;

	if (yyin != NULL && feof(yyin))
		n = asprintf(&str, "%s: %s:%d: %s: unexpected EOF",
		    __progname, filename, lineno, s);
	else if (yytext[0] == '\n')
		n = asprintf(&str,
		    "%s: %s:%d: %s: newline unexpected",
		    __progname, filename, lineno, s);
	else if (isspace((unsigned char)yytext[0]) ||
	    !isprint((unsigned char)yytext[0]))
		n = asprintf(&str,
		    "%s: %s:%d: %s: ascii char 0x%02x unexpected",
		    __progname, filename, lineno, s, yytext[0] & 0xff);
	else
		n = asprintf(&str, "%s: %s:%d: %s: %s unexpected",
		    __progname, filename, lineno, s, yytext);
	if (n == -1)
		err(1, NULL);

	fputs("c[", stdout);
	for (p = str; *p != '\0'; p++) {
		if (*p == '[' || *p == ']' || *p =='\\')
			putchar('\\');
		putchar(*p);
	}
	fputs("]ec\n", stdout);
	free(str);
}

void
fatal(const char *s)
{

	errx(1, "%s:%d: %s", filename, lineno, s);
}

static void
warning(const char *s)
{

	warnx("%s:%d: %s", filename, lineno, s);
}

static void
init(void)
{
	unsigned int i;

	for (i = 0; i < UCHAR_MAX; i++) {
		str_table[i][0] = i;
		str_table[i][1] = '\0';
	}
	if (hcreate(1 << 16) == 0)
		err(1, NULL);
}


static void
usage(void)
{

	fprintf(stderr, "usage: %s [-chlv] [-e expression] [file ...]\n",
	    __progname);
	exit(1);
}

static char *
escape(const char *str)
{
	char *p, *ret;

	ret = malloc(strlen(str) + 1);
	if (ret == NULL)
		err(1, NULL);

	p = ret;
	while (*str != '\0') {
		/*
		 * We get _escaped_ strings here. Single backslashes are
		 * already converted to double backslashes
		 */
		if (*str == '\\') {
			if (*++str == '\\') {
				switch (*++str) {
				case 'a':
					*p++ = '\a';
					break;
				case 'b':
					*p++ = '\b';
					break;
				case 'f':
					*p++ = '\f';
					break;
				case 'n':
					*p++ = '\n';
					break;
				case 'q':
					*p++ = '"';
					break;
				case 'r':
					*p++ = '\r';
					break;
				case 't':
					*p++ = '\t';
					break;
				case '\\':
					*p++ = '\\';
					break;
				}
				str++;
			} else {
				*p++ = '\\';
				*p++ = *str++;
			}
		} else
			*p++ = *str++;
	}
	*p = '\0';
	return (ret);
}

/* ARGSUSED */
static void
sigchld(int signo __attribute__((unused)))
{
	pid_t pid;
	int status, save_errno = errno;

	for (;;) {
		pid = waitpid(dc, &status, WCONTINUED | WNOHANG);
		if (pid == -1) {
			if (errno == EINTR)
				continue;
			_exit(0);
		} else if (pid == 0)
			break;
		if (WIFEXITED(status) || WIFSIGNALED(status))
			_exit(0);
		else
			break;
	}
	errno = save_errno;
}

static const char *
dummy_prompt(void)
{

        return ("");
}

int
main(int argc, char *argv[])
{
	char *q;
	int p[2];
	int ch, i;

	init();
	setvbuf(stdout, NULL, _IOLBF, 0);

	sargv = reallocarray(NULL, argc, sizeof(char *));
	if (sargv == NULL)
		err(1, NULL);

	if ((cmdexpr = strdup("")) == NULL)
		err(1, NULL);
	/* The d debug option is 4.4 BSD bc(1) compatible */
	while ((ch = getopt_long(argc, argv, "cde:hlqv",
	   long_options, NULL)) != -1) {
		switch (ch) {
		case 'c':
		case 'd':
			do_fork = false;
			break;
		case 'e':
			q = cmdexpr;
			if (asprintf(&cmdexpr, "%s%s\n", cmdexpr, optarg) == -1)
				err(1, NULL);
			free(q);
			break;
		case 'h':
			usage();
			break;
		case 'l':
			sargv[sargc++] = _PATH_LIBB;
			break;
		case 'q':
			/* compatibility option */
			break;
		case 'v':
			fprintf(stderr, "%s (BSD bc) %s\n", __progname, BC_VER);
			exit(0);
			break;
		default:
			usage();
		}
	}

	argc -= optind;
	argv += optind;

	interactive = isatty(STDIN_FILENO) && isatty(STDOUT_FILENO) &&
	    isatty(STDERR_FILENO);
	for (i = 0; i < argc; i++)
		sargv[sargc++] = argv[i];

	if (do_fork) {
		if (pipe(p) == -1)
			err(1, "cannot create pipe");
		dc = fork();
		if (dc == -1)
			err(1, "cannot fork");
		else if (dc != 0) {
			signal(SIGCHLD, sigchld);
			close(STDOUT_FILENO);
			dup(p[1]);
			close(p[0]);
			close(p[1]);
		} else {
			close(STDIN_FILENO);
			dup(p[0]);
			close(p[0]);
			close(p[1]);
			execl(_PATH_DC, "dc", "-x", (char *)NULL);
			err(1, "cannot find dc");
		}
	}
	if (interactive) {
		gettty(&ttysaved);
		el = el_init("bc", stdin, stderr, stderr);
		hist = history_init();
		history(hist, &he, H_SETSIZE, 100);
		el_set(el, EL_HIST, history, hist);
		el_set(el, EL_EDITOR, "emacs");
		el_set(el, EL_SIGNAL, 1);
		el_set(el, EL_PROMPT, dummy_prompt);
		el_set(el, EL_ADDFN, "bc_eof", "", bc_eof);
		el_set(el, EL_BIND, "^D", "bc_eof", NULL);
		el_source(el, NULL);
	}
	yywrap();
	return (yyparse());
}
